# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define _with_repolib 1

%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/org/jboss/security/jbosssx/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%define reltag SP7
%define namedversion %{version}.%{reltag}
%define oname jbosssx

Name:           jbosssx2
Version:        2.0.4
Release:        5.%{reltag}.2.1%{?dist}
Epoch:          0
Summary:        JBoss SX
License:        LGPL
Group:          Development/Java
URL:            http://www.jboss.org/
# svn export http://anonsvn.jboss.org/repos/jbossas/projects/security/security-jboss-sx/tags/2.0.4.SP7/ jbosssx-2.0.4.SP7
# Exported revision 110747.
# tar czf jbosssx-2.0.4.SP7.tar.gz jbosssx-2.0.4.SP7
Source0:        jbosssx-%{namedversion}.tar.gz
Source1:        jbosssx2-jpp-depmap.xml
Source2:        jbosssx2-settings.xml
Source3:        http://repository.jboss.org/maven2/org/jboss/jboss-parent/4/jboss-parent-4.pom
Source4:        jbosssx2-client-component-info.xml
Source5:        jbosssx2-component-info.xml
Patch0:         jbosssx2-acl-pom.patch
Patch1:		jbosssx2-buildparentandjbosssx.patch
Patch2:		jbosssx2-buildall.patch

BuildArch:      noarch
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-release
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-jboss-deploy-plugin
BuildRequires:  mojo-maven2-plugin-javacc
BuildRequires:  ant-junit
BuildRequires:  berkeleydb-je3
BuildRequires:  hsqldb
BuildRequires:  jboss-parent5
BuildRequires:  jboss-profiler
BuildRequires:  jboss-test
BuildRequires:	jbossweb
BuildRequires:  junit
#BuildRequires:  opends

BuildRequires:  dtdparser
BuildRequires:  geronimo-jta-1.1-api
BuildRequires:  hibernate3
BuildRequires:  hibernate3-annotations
BuildRequires:  hibernate3-entitymanager
#BuildRequires:  jacc_1_0_api
BuildRequires:	jacc_1_1_api
BuildRequires:  jaspi_1_0_api
BuildRequires:  jaxb_2_1_api
BuildRequires:  jboss4-jmx
BuildRequires:  jboss-common-logging-log4j
BuildRequires:  jboss-javaee
BuildRequires:  jboss-microcontainer2
BuildRequires:  jboss-naming
BuildRequires:  jboss-security-spi
BuildRequires:  jboss-security-xacml
BuildRequires:  jbossxb2
BuildRequires:  glassfish-persistence-1.0b-api
BuildRequires:  slf4j
BuildRequires:  stax_1_0_api
BuildRequires:  glassfish-jaxb
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-jaxp-1.3-apis

Requires:  java >= 0:1.5.0
Requires:  dtdparser
Requires:  hibernate3
Requires:  hibernate3-entitymanager
#Requires:  jacc_1_0_api
Requires:  jacc_1_1_api
Requires:  jaspi_1_0_api
Requires:  jaxb_2_1_api
Requires:  jboss-common-logging-log4j
Requires:  jboss-naming
Requires:  jboss-security-spi
Requires:  jboss-security-xacml
Requires:  jbossxb2
#Requires:  jpa_3_0_api
Requires:  jpa_1_0_api
Requires:  stax_1_0_api
#Requires:  sun-jaxb-2.1-impl
Requires:  glassfish-jaxb


BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss SX.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if %{with_repolib}
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%prep
%setup -q -n %{oname}-%{namedversion}
%patch0 -b .sav0
%patch1 -b .sav1
mkdir -p jbosssx-client/src/main/java
touch jbosssx-client/src/main/java/No.java

%build
cp %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
#mkdir -p $MAVEN_REPO_LOCAL/JPP/maven2/default_poms/
#cp %{SOURCE3} $MAVEN_REPO_LOCAL/JPP/maven2/default_poms/org.jboss-jboss-parent.pom

# To work around a problem with the javacc compiler, we first build
# jbosssx, move the generated sources, and then rebuild everything
mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.test.skip \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
	-fn \
        install

/bin/cp -af jbosssx/target/generated-sources/javacc/org/jboss/security/auth/login/* jbosssx/src/main/java/org/jboss/security/auth/login/

# Now build add
patch -p0 < %{PATCH2}

mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.test.skip \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        install

mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Daggregate \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        javadoc:javadoc


%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}

%add_to_maven_depmap org.jboss.security jboss-security-acl-impl %{namedversion} JPP/%{name} jboss-security-acl-impl
install -m 644 acl/target/jboss-security-acl-impl-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jboss-security-acl-impl-%{namedversion}.jar
%add_to_maven_depmap org.jboss.security %{oname} %{namedversion} JPP/%{name} %{oname}
install -m 644 assembly/target/%{oname}-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{oname}-%{namedversion}.jar
%add_to_maven_depmap org.jboss.security identity-impl %{namedversion} JPP/%{name} identity-impl
install -m 644 identity/target/identity-impl-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/identity-impl-%{namedversion}.jar
%add_to_maven_depmap org.jboss.security jbosssx-bridge-as4 %{namedversion} JPP/%{name} jbosssx-bridge-as4
install -m 644 jbosssx-bridge-as4/target/jbosssx-bridge-as4-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{oname}-bridge-as4-%{namedversion}.jar
%add_to_maven_depmap org.jboss.security jbosssx-client %{namedversion} JPP/%{name} jbosssx-client
install -m 644 jbosssx-client/target/jbosssx-client-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{oname}-client-%{namedversion}.jar
%add_to_maven_depmap org.jboss.security jbosssx-mc-int %{namedversion} JPP/%{name} jbosssx-mc-int
install -m 644 jbosssx-mc-int/target/jbosssx-mc-int-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jbosssx-mc-int-%{namedversion}.jar
%add_to_maven_depmap org.jboss.security jbosssx-bare %{namedversion} JPP/%{name} jbosssx-bare
install -m 644 jbosssx/target/jbosssx-bare.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jbosssx-bare-%{namedversion}.jar
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{namedversion}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{namedversion}||g"`; done)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
%add_to_maven_depmap org.jboss.security %{oname}-pom %{namedversion} JPP/%{name} %{oname}-pom
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{oname}-pom.pom
%add_to_maven_depmap org.jboss.security %{oname}-parent %{namedversion} JPP/%{name} %{oname}-parent
install -m 644 parent/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{oname}-parent.pom
install -m 644 acl/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jboss-security-acl-impl.pom
install -m 644 assembly/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{oname}.pom
install -m 644 identity/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-identity-impl.pom
install -m 644 jbosssx-bridge-as4/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jbosssx-bridge-as4.pom
install -m 644 jbosssx-client/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jbosssx-client.pom
install -m 644 jbosssx-mc-int/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jbosssx-mc-int.pom
install -m 644 jbosssx/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jbosssx-bare.pom

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{namedversion}
cp -rf target/site/apidocs/* \
                  $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{namedversion}
ln -s %{name}-%{namedversion} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%if %{with_repolib}
tag=`echo %{namedversion}-brew`
sed -i "s/@VERSION@/$tag/g" %{SOURCE5}
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{SOURCE5}
install -d -m 755 $RPM_BUILD_ROOT%{repodir}
install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
install -m 755 %{SOURCE5} $RPM_BUILD_ROOT%{repodir}/component-info.xml
install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{repodirsrc}
install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{repodirsrc}
#install -m 755 %{SOURCE3} $RPM_BUILD_ROOT%{repodirsrc}
#install -m 755 %{SOURCE4} $RPM_BUILD_ROOT%{repodirsrc}
install -m 755 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}
install -m 755 %{PATCH1} $RPM_BUILD_ROOT%{repodirsrc}
install -m 755 %{PATCH2} $RPM_BUILD_ROOT%{repodirsrc}
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}/jboss-security-acl-impl-%{namedversion}.jar $RPM_BUILD_ROOT%{repodirlib}/jbosssx-jboss-security-acl-impl.jar
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}/%{oname}-%{namedversion}.jar $RPM_BUILD_ROOT%{repodirlib}/jbosssx.jar
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}/identity-impl-%{namedversion}.jar $RPM_BUILD_ROOT%{repodirlib}/jbosssx-identity-impl.jar
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}/%{oname}-bridge-as4-%{namedversion}.jar $RPM_BUILD_ROOT%{repodirlib}/jbosssx-bridge-as4.jar
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}/%{oname}-client-%{namedversion}.jar $RPM_BUILD_ROOT%{repodirlib}/jbosssx-client.jar
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}/jbosssx-mc-int-%{namedversion}.jar $RPM_BUILD_ROOT%{repodirlib}/jbosssx-mc-int.jar
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}/jbosssx-bare-%{namedversion}.jar $RPM_BUILD_ROOT%{repodirlib}/jbosssx-bare.jar

cp -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{oname}-pom.pom $RPM_BUILD_ROOT%{repodirlib}/jbosssx-pom.pom
cp -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{oname}-parent.pom $RPM_BUILD_ROOT%{repodirlib}/jbosssx-parent.pom
cp -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jboss-security-acl-impl.pom $RPM_BUILD_ROOT%{repodirlib}/jbosssx-jboss-security-acl-impl.pom
cp -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{oname}.pom $RPM_BUILD_ROOT%{repodirlib}/jbosssx.pom
cp -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-identity-impl.pom $RPM_BUILD_ROOT%{repodirlib}/jbosssx-identity-impl.pom
cp -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jbosssx-bridge-as4.pom $RPM_BUILD_ROOT%{repodirlib}/jbosssx-bridge-as4.pom
cp -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jbosssx-client.pom $RPM_BUILD_ROOT%{repodirlib}/jbosssx-client.pom
cp -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jbosssx-mc-int.pom $RPM_BUILD_ROOT%{repodirlib}/jbosssx-mc-int.pom
cp -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jbosssx-bare.pom $RPM_BUILD_ROOT%{repodirlib}/jbosssx-bare.pom

%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{namedversion}
%doc %{_javadocdir}/%{name}

%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{repodir}
%endif

%changelog
* Wed Mar 23 2011 Permaine Cheung <pcheung@redhat.com> - 0:2.0.4-5.SP7.2.1
- Upgrade to 2.0.4.SP7
- Change BR jboss-parent to jboss-parent5

* Thu Jun 03 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.0.4-4.SP4.1
- Upgrading to SP4 

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.0.4-3.SP3.2.1.1.1
- rebuilt

* Tue Apr 20 2010 Yiqiao Wang <yiwang@redhat.com> - 0:2.0.4-3.SP3.2.1.1
- Rebuild 

* Thu Mar 11 2010 Yiqiao Wang <yiwang@redhat.com> - 0:2.0.4-3.SP3.2.1
- Merge from RHEL-4-EP-5

* Wed Mar 03 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.0.4-3.SP3.2
- Change (B)R jacc_1_0_api to jacc_1_1_api
- Change R jpa_3_0_api to jpa_1_0_api
- Add BR jbossweb

* Wed Feb 03 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.0.4-3.SP3.1
- Upgrade to 2.0.4.SP3

* Tue Jan 19 2010 Martha Benitez <mbenitez@redhat.com> - 2.0.4-2.SP2.1.1
- Fix depmap entry for hibernate
- Add jboss-javaee-parent.pom as Source

* Wed Nov 11 2009 Yong Yang <yyang@redhat.com> - 0:2.0.4-2.SP2.1
- Upgrade to 2.0.4.SP2
- Add repolib

* Mon Sep 21 2009 Fernando Nasser <fnasser@redhat.com> - 0:2.0.4-2.SP1.1
- Upgrade to 2.0.4.SP1

* Thu Aug 20 2009 Martha Benitez <mbenitez@redhat.com> - 0:2.0.4-1.1
- Change R sun-jaxb-2.1-impl to glassfish-jaxb

* Thu Aug 20 2009 Deepak Bhole <dbhole@redhat.com> - 0:2.0.4-1
- Upgrade to 2.0.4

* Thu Aug 20 2009 Fernando Nasser <fnasser@redhat.com> - 0:2.0.3.1-1.1
- First Brew build

* Tue Jun 23 2009 Ralph Apel <r.apel@r-apel.de> - 0:2.0.3.1-1.jpp5
- 2.0.3.SP1 

* Mon Jun 01 2009 Ralph Apel <r.apel@r-apel.de> - 0:2.0.0-1.jpp5
- 2.0.0.GA as jbossxb2

